﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2023.1.2),
    on October 12, 2023, at 12:04
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

# --- Import packages ---
from psychopy import locale_setup
from psychopy import prefs
from psychopy import plugins
plugins.activatePlugins()
prefs.hardware['audioLib'] = 'ptb'
prefs.hardware['audioLatencyMode'] = '3'
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard

# Run 'Before Experiment' code from codeRandomizer
stress = [ ]
accuracy = [ ]

# Run 'Before Experiment' code from codeYourResponse
msg2 = ' '
# Run 'Before Experiment' code from code
msg = ' '
# Run 'Before Experiment' code from codeYourResponse
msg2 = ' '
# Run 'Before Experiment' code from code
msg = ' '


# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2023.1.2'
expName = 'time_generalization_00'  # from the Builder filename that created this script
expInfo = {
    'participant': f"{randint(0, 999999):06.0f}",
    'session': '001',
    'gender': '',
    'age': '',
}
# --- Show participant info dialog --
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\experimentalni psychologie\\psychopy\\ONLINE\\time_gen_00_A_01\\time_gen00_A_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# --- Setup the Window ---
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=0, 
    winType='pyglet', allowStencil=False,
    monitor='testMonitor', color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb',
    backgroundImage='', backgroundFit='none',
    blendMode='avg', useFBO=True, 
    units='height')
win.mouseVisible = False
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# --- Setup input devices ---
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# --- Initialize components for Routine "randomizer" ---
# Run 'Begin Experiment' code from codeRandomizer
import random

# Generate a random 0 or 1
randNum = random.randint(0, 1)
if randNum == 1:
    stress = 1
    accuracy = 0
else:
    stress = 0
    accuracy = 1

# --- Initialize components for Routine "WelcomeScreen" ---
textWelcomeScreen = visual.TextStim(win=win, name='textWelcomeScreen',
    text='Welcome to the temporal generalization experiment.\n',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
text = visual.TextStim(win=win, name='text',
    text='The experiment is about to start.\n\nIt will take cca 25 minutes. Please follow the instructions on the screen.\n\nPress SPACEBAR to begin.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
keyWelcome = keyboard.Keyboard()

# --- Initialize components for Routine "experimentDescription" ---
textExperimentDescription = visual.TextStim(win=win, name='textExperimentDescription',
    text='In this experiment, two stimuli will be presented at each trial. You will be asked to judge, if they both had SAME or DIFFERENT duration. \n\nThe task will remain constant through all the trials. \n',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textExperimentDescriptionSpacebar = visual.TextStim(win=win, name='textExperimentDescriptionSpacebar',
    text='Press SPACEBAR to continue.',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respExperimentDescription = keyboard.Keyboard()

# --- Initialize components for Routine "experimentDescription3" ---
textExperimentDescription3 = visual.TextStim(win=win, name='textExperimentDescription3',
    text='Please put two fingers of your dominant hand on keys B and N and keep them ready throughout the trials. Use B to indicate the same length and N to indicate that the length of the two stimuli differed. \n\n',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textExperimentDescriptionSpacebar_3 = visual.TextStim(win=win, name='textExperimentDescriptionSpacebar_3',
    text='Let us start with 10 practice trials.\nPress SPACEBAR to proceed.',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respExperimentDescription_3 = keyboard.Keyboard()

# --- Initialize components for Routine "blank2s" ---
textBlank3s = visual.TextStim(win=win, name='textBlank3s',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "standard" ---
polygonStandard = visual.Rect(
    win=win, name='polygonStandard',
    width=(0.35, 0.35)[0], height=(0.35, 0.35)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='grey', fillColor='grey',
    opacity=None, depth=0.0, interpolate=True)
textStandard = visual.TextStim(win=win, name='textStandard',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "trial" ---
polygonBlackSquare = visual.Rect(
    win=win, name='polygonBlackSquare',
    width=(0.35, 0.35)[0], height=(0.35, 0.35)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='grey', fillColor='grey',
    opacity=None, depth=0.0, interpolate=True)
textTrialBorN = visual.TextStim(win=win, name='textTrialBorN',
    text='Did the stimuli had same or different duration?\n\nPress B for SAME or N for DIFFERENT',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respBorN = keyboard.Keyboard()

# --- Initialize components for Routine "yourResponseScreen" ---
textYourResponse = visual.TextStim(win=win, name='textYourResponse',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "feedback" ---
textFeedback = visual.TextStim(win=win, name='textFeedback',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "SeriesOfBlocksDescription" ---
textBlocksDescription = visual.TextStim(win=win, name='textBlocksDescription',
    text='There will be two series of blocks of trials, each containing 6 blocks of 10 trials. In total, there will be 120 trials. Feel free to rest between the blocks and between the series of blocks.\n\nThe only difference between the two series consist in the presence (or absence) of the feedback about correctness of your answers.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textExperimentDescriptionSpacebar_2 = visual.TextStim(win=win, name='textExperimentDescriptionSpacebar_2',
    text='Press SPACEBAR to continue.',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respExperimentDescription_2 = keyboard.Keyboard()

# --- Initialize components for Routine "blank2s" ---
textBlank3s = visual.TextStim(win=win, name='textBlank3s',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "seriesBlocks" ---
textSeriesBlocks = visual.TextStim(win=win, name='textSeriesBlocks',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textSeriesBlocksSpacebar = visual.TextStim(win=win, name='textSeriesBlocksSpacebar',
    text='Press SPACEBAR when ready',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respSeriesBlocks = keyboard.Keyboard()

# --- Initialize components for Routine "blockStart" ---
textBlockStart = visual.TextStim(win=win, name='textBlockStart',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_respBlockStart = keyboard.Keyboard()

# --- Initialize components for Routine "instrusctionSpecific" ---
textInstructionsSpacebar_2 = visual.TextStim(win=win, name='textInstructionsSpacebar_2',
    text='Press SPACEBAR to start the trials.',
    font='Open Sans',
    pos=(0, -.35), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_resp_2 = keyboard.Keyboard()
textInstructionsStress = visual.TextStim(win=win, name='textInstructionsStress',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);

# --- Initialize components for Routine "instructionsSpecific2" ---
textInstructions = visual.TextStim(win=win, name='textInstructions',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_resp = keyboard.Keyboard()
textInstructionsSpacebar = visual.TextStim(win=win, name='textInstructionsSpacebar',
    text='Press SPACEBAR to start the trials.',
    font='Open Sans',
    pos=(0, -.35), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);

# --- Initialize components for Routine "blank2s" ---
textBlank3s = visual.TextStim(win=win, name='textBlank3s',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "standard" ---
polygonStandard = visual.Rect(
    win=win, name='polygonStandard',
    width=(0.35, 0.35)[0], height=(0.35, 0.35)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='grey', fillColor='grey',
    opacity=None, depth=0.0, interpolate=True)
textStandard = visual.TextStim(win=win, name='textStandard',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "trial" ---
polygonBlackSquare = visual.Rect(
    win=win, name='polygonBlackSquare',
    width=(0.35, 0.35)[0], height=(0.35, 0.35)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='grey', fillColor='grey',
    opacity=None, depth=0.0, interpolate=True)
textTrialBorN = visual.TextStim(win=win, name='textTrialBorN',
    text='Did the stimuli had same or different duration?\n\nPress B for SAME or N for DIFFERENT',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respBorN = keyboard.Keyboard()

# --- Initialize components for Routine "yourResponseScreen" ---
textYourResponse = visual.TextStim(win=win, name='textYourResponse',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "feedback" ---
textFeedback = visual.TextStim(win=win, name='textFeedback',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "GoodbyeScreen" ---
textGoodbyeScreen = visual.TextStim(win=win, name='textGoodbyeScreen',
    text='Thanks for participating.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.Clock()  # to track time remaining of each (possibly non-slip) routine 

# --- Prepare to start Routine "randomizer" ---
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
randomizerComponents = []
for thisComponent in randomizerComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "randomizer" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in randomizerComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "randomizer" ---
for thisComponent in randomizerComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# Run 'End Routine' code from codeRandomizer
thisExp.addData('stress', stress)
thisExp.addData('accuracy', accuracy)
# the Routine "randomizer" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "WelcomeScreen" ---
continueRoutine = True
# update component parameters for each repeat
keyWelcome.keys = []
keyWelcome.rt = []
_keyWelcome_allKeys = []
# keep track of which components have finished
WelcomeScreenComponents = [textWelcomeScreen, text, keyWelcome]
for thisComponent in WelcomeScreenComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "WelcomeScreen" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textWelcomeScreen* updates
    
    # if textWelcomeScreen is starting this frame...
    if textWelcomeScreen.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textWelcomeScreen.frameNStart = frameN  # exact frame index
        textWelcomeScreen.tStart = t  # local t and not account for scr refresh
        textWelcomeScreen.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textWelcomeScreen, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textWelcomeScreen.started')
        # update status
        textWelcomeScreen.status = STARTED
        textWelcomeScreen.setAutoDraw(True)
    
    # if textWelcomeScreen is active this frame...
    if textWelcomeScreen.status == STARTED:
        # update params
        pass
    
    # if textWelcomeScreen is stopping this frame...
    if textWelcomeScreen.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > textWelcomeScreen.tStartRefresh + 3.0-frameTolerance:
            # keep track of stop time/frame for later
            textWelcomeScreen.tStop = t  # not accounting for scr refresh
            textWelcomeScreen.frameNStop = frameN  # exact frame index
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textWelcomeScreen.stopped')
            # update status
            textWelcomeScreen.status = FINISHED
            textWelcomeScreen.setAutoDraw(False)
    
    # *text* updates
    
    # if text is starting this frame...
    if text.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
        # keep track of start time/frame for later
        text.frameNStart = frameN  # exact frame index
        text.tStart = t  # local t and not account for scr refresh
        text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'text.started')
        # update status
        text.status = STARTED
        text.setAutoDraw(True)
    
    # if text is active this frame...
    if text.status == STARTED:
        # update params
        pass
    
    # *keyWelcome* updates
    waitOnFlip = False
    
    # if keyWelcome is starting this frame...
    if keyWelcome.status == NOT_STARTED and tThisFlip >= 3-frameTolerance:
        # keep track of start time/frame for later
        keyWelcome.frameNStart = frameN  # exact frame index
        keyWelcome.tStart = t  # local t and not account for scr refresh
        keyWelcome.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(keyWelcome, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'keyWelcome.started')
        # update status
        keyWelcome.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(keyWelcome.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(keyWelcome.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if keyWelcome.status == STARTED and not waitOnFlip:
        theseKeys = keyWelcome.getKeys(keyList=['space'], waitRelease=False)
        _keyWelcome_allKeys.extend(theseKeys)
        if len(_keyWelcome_allKeys):
            keyWelcome.keys = _keyWelcome_allKeys[-1].name  # just the last key pressed
            keyWelcome.rt = _keyWelcome_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in WelcomeScreenComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "WelcomeScreen" ---
for thisComponent in WelcomeScreenComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if keyWelcome.keys in ['', [], None]:  # No response was made
    keyWelcome.keys = None
thisExp.addData('keyWelcome.keys',keyWelcome.keys)
if keyWelcome.keys != None:  # we had a response
    thisExp.addData('keyWelcome.rt', keyWelcome.rt)
thisExp.nextEntry()
# the Routine "WelcomeScreen" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "experimentDescription" ---
continueRoutine = True
# update component parameters for each repeat
key_respExperimentDescription.keys = []
key_respExperimentDescription.rt = []
_key_respExperimentDescription_allKeys = []
# keep track of which components have finished
experimentDescriptionComponents = [textExperimentDescription, textExperimentDescriptionSpacebar, key_respExperimentDescription]
for thisComponent in experimentDescriptionComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "experimentDescription" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textExperimentDescription* updates
    
    # if textExperimentDescription is starting this frame...
    if textExperimentDescription.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescription.frameNStart = frameN  # exact frame index
        textExperimentDescription.tStart = t  # local t and not account for scr refresh
        textExperimentDescription.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescription, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescription.started')
        # update status
        textExperimentDescription.status = STARTED
        textExperimentDescription.setAutoDraw(True)
    
    # if textExperimentDescription is active this frame...
    if textExperimentDescription.status == STARTED:
        # update params
        pass
    
    # *textExperimentDescriptionSpacebar* updates
    
    # if textExperimentDescriptionSpacebar is starting this frame...
    if textExperimentDescriptionSpacebar.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescriptionSpacebar.frameNStart = frameN  # exact frame index
        textExperimentDescriptionSpacebar.tStart = t  # local t and not account for scr refresh
        textExperimentDescriptionSpacebar.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescriptionSpacebar, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescriptionSpacebar.started')
        # update status
        textExperimentDescriptionSpacebar.status = STARTED
        textExperimentDescriptionSpacebar.setAutoDraw(True)
    
    # if textExperimentDescriptionSpacebar is active this frame...
    if textExperimentDescriptionSpacebar.status == STARTED:
        # update params
        pass
    
    # *key_respExperimentDescription* updates
    waitOnFlip = False
    
    # if key_respExperimentDescription is starting this frame...
    if key_respExperimentDescription.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        key_respExperimentDescription.frameNStart = frameN  # exact frame index
        key_respExperimentDescription.tStart = t  # local t and not account for scr refresh
        key_respExperimentDescription.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_respExperimentDescription, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'key_respExperimentDescription.started')
        # update status
        key_respExperimentDescription.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_respExperimentDescription.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_respExperimentDescription.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_respExperimentDescription.status == STARTED and not waitOnFlip:
        theseKeys = key_respExperimentDescription.getKeys(keyList=['space'], waitRelease=False)
        _key_respExperimentDescription_allKeys.extend(theseKeys)
        if len(_key_respExperimentDescription_allKeys):
            key_respExperimentDescription.keys = _key_respExperimentDescription_allKeys[-1].name  # just the last key pressed
            key_respExperimentDescription.rt = _key_respExperimentDescription_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in experimentDescriptionComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "experimentDescription" ---
for thisComponent in experimentDescriptionComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_respExperimentDescription.keys in ['', [], None]:  # No response was made
    key_respExperimentDescription.keys = None
thisExp.addData('key_respExperimentDescription.keys',key_respExperimentDescription.keys)
if key_respExperimentDescription.keys != None:  # we had a response
    thisExp.addData('key_respExperimentDescription.rt', key_respExperimentDescription.rt)
thisExp.nextEntry()
# the Routine "experimentDescription" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "experimentDescription3" ---
continueRoutine = True
# update component parameters for each repeat
key_respExperimentDescription_3.keys = []
key_respExperimentDescription_3.rt = []
_key_respExperimentDescription_3_allKeys = []
# keep track of which components have finished
experimentDescription3Components = [textExperimentDescription3, textExperimentDescriptionSpacebar_3, key_respExperimentDescription_3]
for thisComponent in experimentDescription3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "experimentDescription3" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textExperimentDescription3* updates
    
    # if textExperimentDescription3 is starting this frame...
    if textExperimentDescription3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescription3.frameNStart = frameN  # exact frame index
        textExperimentDescription3.tStart = t  # local t and not account for scr refresh
        textExperimentDescription3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescription3, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescription3.started')
        # update status
        textExperimentDescription3.status = STARTED
        textExperimentDescription3.setAutoDraw(True)
    
    # if textExperimentDescription3 is active this frame...
    if textExperimentDescription3.status == STARTED:
        # update params
        pass
    
    # *textExperimentDescriptionSpacebar_3* updates
    
    # if textExperimentDescriptionSpacebar_3 is starting this frame...
    if textExperimentDescriptionSpacebar_3.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescriptionSpacebar_3.frameNStart = frameN  # exact frame index
        textExperimentDescriptionSpacebar_3.tStart = t  # local t and not account for scr refresh
        textExperimentDescriptionSpacebar_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescriptionSpacebar_3, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescriptionSpacebar_3.started')
        # update status
        textExperimentDescriptionSpacebar_3.status = STARTED
        textExperimentDescriptionSpacebar_3.setAutoDraw(True)
    
    # if textExperimentDescriptionSpacebar_3 is active this frame...
    if textExperimentDescriptionSpacebar_3.status == STARTED:
        # update params
        pass
    
    # *key_respExperimentDescription_3* updates
    waitOnFlip = False
    
    # if key_respExperimentDescription_3 is starting this frame...
    if key_respExperimentDescription_3.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        key_respExperimentDescription_3.frameNStart = frameN  # exact frame index
        key_respExperimentDescription_3.tStart = t  # local t and not account for scr refresh
        key_respExperimentDescription_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_respExperimentDescription_3, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'key_respExperimentDescription_3.started')
        # update status
        key_respExperimentDescription_3.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_respExperimentDescription_3.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_respExperimentDescription_3.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_respExperimentDescription_3.status == STARTED and not waitOnFlip:
        theseKeys = key_respExperimentDescription_3.getKeys(keyList=['space'], waitRelease=False)
        _key_respExperimentDescription_3_allKeys.extend(theseKeys)
        if len(_key_respExperimentDescription_3_allKeys):
            key_respExperimentDescription_3.keys = _key_respExperimentDescription_3_allKeys[-1].name  # just the last key pressed
            key_respExperimentDescription_3.rt = _key_respExperimentDescription_3_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in experimentDescription3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "experimentDescription3" ---
for thisComponent in experimentDescription3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_respExperimentDescription_3.keys in ['', [], None]:  # No response was made
    key_respExperimentDescription_3.keys = None
thisExp.addData('key_respExperimentDescription_3.keys',key_respExperimentDescription_3.keys)
if key_respExperimentDescription_3.keys != None:  # we had a response
    thisExp.addData('key_respExperimentDescription_3.rt', key_respExperimentDescription_3.rt)
thisExp.nextEntry()
# the Routine "experimentDescription3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
training = data.TrialHandler(nReps=1.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('timesTraining.xlsx'),
    seed=None, name='training')
thisExp.addLoop(training)  # add the loop to the experiment
thisTraining = training.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTraining.rgb)
if thisTraining != None:
    for paramName in thisTraining:
        exec('{} = thisTraining[paramName]'.format(paramName))

for thisTraining in training:
    currentLoop = training
    # abbreviate parameter names if possible (e.g. rgb = thisTraining.rgb)
    if thisTraining != None:
        for paramName in thisTraining:
            exec('{} = thisTraining[paramName]'.format(paramName))
    
    # --- Prepare to start Routine "blank2s" ---
    continueRoutine = True
    # update component parameters for each repeat
    # keep track of which components have finished
    blank2sComponents = [textBlank3s]
    for thisComponent in blank2sComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "blank2s" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 2.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textBlank3s* updates
        
        # if textBlank3s is starting this frame...
        if textBlank3s.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textBlank3s.frameNStart = frameN  # exact frame index
            textBlank3s.tStart = t  # local t and not account for scr refresh
            textBlank3s.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textBlank3s, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textBlank3s.started')
            # update status
            textBlank3s.status = STARTED
            textBlank3s.setAutoDraw(True)
        
        # if textBlank3s is active this frame...
        if textBlank3s.status == STARTED:
            # update params
            pass
        
        # if textBlank3s is stopping this frame...
        if textBlank3s.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textBlank3s.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                textBlank3s.tStop = t  # not accounting for scr refresh
                textBlank3s.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textBlank3s.stopped')
                # update status
                textBlank3s.status = FINISHED
                textBlank3s.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in blank2sComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "blank2s" ---
    for thisComponent in blank2sComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-2.000000)
    
    # --- Prepare to start Routine "standard" ---
    continueRoutine = True
    # update component parameters for each repeat
    # keep track of which components have finished
    standardComponents = [polygonStandard, textStandard]
    for thisComponent in standardComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "standard" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 3.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *polygonStandard* updates
        
        # if polygonStandard is starting this frame...
        if polygonStandard.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygonStandard.frameNStart = frameN  # exact frame index
            polygonStandard.tStart = t  # local t and not account for scr refresh
            polygonStandard.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygonStandard, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'polygonStandard.started')
            # update status
            polygonStandard.status = STARTED
            polygonStandard.setAutoDraw(True)
        
        # if polygonStandard is active this frame...
        if polygonStandard.status == STARTED:
            # update params
            pass
        
        # if polygonStandard is stopping this frame...
        if polygonStandard.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > polygonStandard.tStartRefresh + 1-frameTolerance:
                # keep track of stop time/frame for later
                polygonStandard.tStop = t  # not accounting for scr refresh
                polygonStandard.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'polygonStandard.stopped')
                # update status
                polygonStandard.status = FINISHED
                polygonStandard.setAutoDraw(False)
        
        # *textStandard* updates
        
        # if textStandard is starting this frame...
        if textStandard.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
            # keep track of start time/frame for later
            textStandard.frameNStart = frameN  # exact frame index
            textStandard.tStart = t  # local t and not account for scr refresh
            textStandard.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textStandard, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textStandard.started')
            # update status
            textStandard.status = STARTED
            textStandard.setAutoDraw(True)
        
        # if textStandard is active this frame...
        if textStandard.status == STARTED:
            # update params
            pass
        
        # if textStandard is stopping this frame...
        if textStandard.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textStandard.tStartRefresh + 2.0-frameTolerance:
                # keep track of stop time/frame for later
                textStandard.tStop = t  # not accounting for scr refresh
                textStandard.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textStandard.stopped')
                # update status
                textStandard.status = FINISHED
                textStandard.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in standardComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "standard" ---
    for thisComponent in standardComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-3.000000)
    
    # --- Prepare to start Routine "trial" ---
    continueRoutine = True
    # update component parameters for each repeat
    key_respBorN.keys = []
    key_respBorN.rt = []
    _key_respBorN_allKeys = []
    # keep track of which components have finished
    trialComponents = [polygonBlackSquare, textTrialBorN, key_respBorN]
    for thisComponent in trialComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "trial" ---
    routineForceEnded = not continueRoutine
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *polygonBlackSquare* updates
        
        # if polygonBlackSquare is starting this frame...
        if polygonBlackSquare.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygonBlackSquare.frameNStart = frameN  # exact frame index
            polygonBlackSquare.tStart = t  # local t and not account for scr refresh
            polygonBlackSquare.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygonBlackSquare, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'polygonBlackSquare.started')
            # update status
            polygonBlackSquare.status = STARTED
            polygonBlackSquare.setAutoDraw(True)
        
        # if polygonBlackSquare is active this frame...
        if polygonBlackSquare.status == STARTED:
            # update params
            pass
        
        # if polygonBlackSquare is stopping this frame...
        if polygonBlackSquare.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > polygonBlackSquare.tStartRefresh + duration-frameTolerance:
                # keep track of stop time/frame for later
                polygonBlackSquare.tStop = t  # not accounting for scr refresh
                polygonBlackSquare.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'polygonBlackSquare.stopped')
                # update status
                polygonBlackSquare.status = FINISHED
                polygonBlackSquare.setAutoDraw(False)
        
        # *textTrialBorN* updates
        
        # if textTrialBorN is starting this frame...
        if textTrialBorN.status == NOT_STARTED and tThisFlip >= duration-frameTolerance:
            # keep track of start time/frame for later
            textTrialBorN.frameNStart = frameN  # exact frame index
            textTrialBorN.tStart = t  # local t and not account for scr refresh
            textTrialBorN.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTrialBorN, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textTrialBorN.started')
            # update status
            textTrialBorN.status = STARTED
            textTrialBorN.setAutoDraw(True)
        
        # if textTrialBorN is active this frame...
        if textTrialBorN.status == STARTED:
            # update params
            pass
        
        # *key_respBorN* updates
        waitOnFlip = False
        
        # if key_respBorN is starting this frame...
        if key_respBorN.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_respBorN.frameNStart = frameN  # exact frame index
            key_respBorN.tStart = t  # local t and not account for scr refresh
            key_respBorN.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_respBorN, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'key_respBorN.started')
            # update status
            key_respBorN.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_respBorN.clock.reset)  # t=0 on next screen flip
        if key_respBorN.status == STARTED and not waitOnFlip:
            theseKeys = key_respBorN.getKeys(keyList=['b','n'], waitRelease=False)
            _key_respBorN_allKeys.extend(theseKeys)
            if len(_key_respBorN_allKeys):
                key_respBorN.keys = _key_respBorN_allKeys[0].name  # just the first key pressed
                key_respBorN.rt = _key_respBorN_allKeys[0].rt
                # was this correct?
                if (key_respBorN.keys == str(corrAns)) or (key_respBorN.keys == corrAns):
                    key_respBorN.corr = 1
                else:
                    key_respBorN.corr = 0
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "trial" ---
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if key_respBorN.keys in ['', [], None]:  # No response was made
        key_respBorN.keys = None
        # was no response the correct answer?!
        if str(corrAns).lower() == 'none':
           key_respBorN.corr = 1;  # correct non-response
        else:
           key_respBorN.corr = 0;  # failed to respond (incorrectly)
    # store data for training (TrialHandler)
    training.addData('key_respBorN.keys',key_respBorN.keys)
    training.addData('key_respBorN.corr', key_respBorN.corr)
    if key_respBorN.keys != None:  # we had a response
        training.addData('key_respBorN.rt', key_respBorN.rt)
    # the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # --- Prepare to start Routine "yourResponseScreen" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from codeYourResponse
    if key_respBorN.keys == 'b':
        msg2 = 'You chose SAME'
    else:
        msg2 = 'You chose DIFFERENT'  
    textYourResponse.setText(msg2)
    # keep track of which components have finished
    yourResponseScreenComponents = [textYourResponse]
    for thisComponent in yourResponseScreenComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "yourResponseScreen" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 1.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textYourResponse* updates
        
        # if textYourResponse is starting this frame...
        if textYourResponse.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textYourResponse.frameNStart = frameN  # exact frame index
            textYourResponse.tStart = t  # local t and not account for scr refresh
            textYourResponse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textYourResponse, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textYourResponse.started')
            # update status
            textYourResponse.status = STARTED
            textYourResponse.setAutoDraw(True)
        
        # if textYourResponse is active this frame...
        if textYourResponse.status == STARTED:
            # update params
            pass
        
        # if textYourResponse is stopping this frame...
        if textYourResponse.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textYourResponse.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                textYourResponse.tStop = t  # not accounting for scr refresh
                textYourResponse.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textYourResponse.stopped')
                # update status
                textYourResponse.status = FINISHED
                textYourResponse.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in yourResponseScreenComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "yourResponseScreen" ---
    for thisComponent in yourResponseScreenComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-1.000000)
    
    # --- Prepare to start Routine "feedback" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from code
    if key_respBorN.corr:
        msg = 'Correct'
    else:
        msg = 'Uncorrect'    
    textFeedback.setText(msg)
    # keep track of which components have finished
    feedbackComponents = [textFeedback]
    for thisComponent in feedbackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "feedback" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 1.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textFeedback* updates
        
        # if textFeedback is starting this frame...
        if textFeedback.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textFeedback.frameNStart = frameN  # exact frame index
            textFeedback.tStart = t  # local t and not account for scr refresh
            textFeedback.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textFeedback, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textFeedback.started')
            # update status
            textFeedback.status = STARTED
            textFeedback.setAutoDraw(True)
        
        # if textFeedback is active this frame...
        if textFeedback.status == STARTED:
            # update params
            pass
        
        # if textFeedback is stopping this frame...
        if textFeedback.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textFeedback.tStartRefresh + 1-frameTolerance:
                # keep track of stop time/frame for later
                textFeedback.tStop = t  # not accounting for scr refresh
                textFeedback.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textFeedback.stopped')
                # update status
                textFeedback.status = FINISHED
                textFeedback.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "feedback" ---
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-1.000000)
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'training'

# get names of stimulus parameters
if training.trialList in ([], [None], None):
    params = []
else:
    params = training.trialList[0].keys()
# save data for this loop
training.saveAsText(filename + 'training.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# --- Prepare to start Routine "SeriesOfBlocksDescription" ---
continueRoutine = True
# update component parameters for each repeat
key_respExperimentDescription_2.keys = []
key_respExperimentDescription_2.rt = []
_key_respExperimentDescription_2_allKeys = []
# keep track of which components have finished
SeriesOfBlocksDescriptionComponents = [textBlocksDescription, textExperimentDescriptionSpacebar_2, key_respExperimentDescription_2]
for thisComponent in SeriesOfBlocksDescriptionComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "SeriesOfBlocksDescription" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textBlocksDescription* updates
    
    # if textBlocksDescription is starting this frame...
    if textBlocksDescription.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textBlocksDescription.frameNStart = frameN  # exact frame index
        textBlocksDescription.tStart = t  # local t and not account for scr refresh
        textBlocksDescription.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textBlocksDescription, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textBlocksDescription.started')
        # update status
        textBlocksDescription.status = STARTED
        textBlocksDescription.setAutoDraw(True)
    
    # if textBlocksDescription is active this frame...
    if textBlocksDescription.status == STARTED:
        # update params
        pass
    
    # *textExperimentDescriptionSpacebar_2* updates
    
    # if textExperimentDescriptionSpacebar_2 is starting this frame...
    if textExperimentDescriptionSpacebar_2.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescriptionSpacebar_2.frameNStart = frameN  # exact frame index
        textExperimentDescriptionSpacebar_2.tStart = t  # local t and not account for scr refresh
        textExperimentDescriptionSpacebar_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescriptionSpacebar_2, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescriptionSpacebar_2.started')
        # update status
        textExperimentDescriptionSpacebar_2.status = STARTED
        textExperimentDescriptionSpacebar_2.setAutoDraw(True)
    
    # if textExperimentDescriptionSpacebar_2 is active this frame...
    if textExperimentDescriptionSpacebar_2.status == STARTED:
        # update params
        pass
    
    # *key_respExperimentDescription_2* updates
    waitOnFlip = False
    
    # if key_respExperimentDescription_2 is starting this frame...
    if key_respExperimentDescription_2.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        key_respExperimentDescription_2.frameNStart = frameN  # exact frame index
        key_respExperimentDescription_2.tStart = t  # local t and not account for scr refresh
        key_respExperimentDescription_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_respExperimentDescription_2, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'key_respExperimentDescription_2.started')
        # update status
        key_respExperimentDescription_2.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_respExperimentDescription_2.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_respExperimentDescription_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_respExperimentDescription_2.status == STARTED and not waitOnFlip:
        theseKeys = key_respExperimentDescription_2.getKeys(keyList=['space'], waitRelease=False)
        _key_respExperimentDescription_2_allKeys.extend(theseKeys)
        if len(_key_respExperimentDescription_2_allKeys):
            key_respExperimentDescription_2.keys = _key_respExperimentDescription_2_allKeys[-1].name  # just the last key pressed
            key_respExperimentDescription_2.rt = _key_respExperimentDescription_2_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in SeriesOfBlocksDescriptionComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "SeriesOfBlocksDescription" ---
for thisComponent in SeriesOfBlocksDescriptionComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_respExperimentDescription_2.keys in ['', [], None]:  # No response was made
    key_respExperimentDescription_2.keys = None
thisExp.addData('key_respExperimentDescription_2.keys',key_respExperimentDescription_2.keys)
if key_respExperimentDescription_2.keys != None:  # we had a response
    thisExp.addData('key_respExperimentDescription_2.rt', key_respExperimentDescription_2.rt)
thisExp.nextEntry()
# the Routine "SeriesOfBlocksDescription" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
blockSelector = data.TrialHandler(nReps=1.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('versions.xlsx'),
    seed=None, name='blockSelector')
thisExp.addLoop(blockSelector)  # add the loop to the experiment
thisBlockSelector = blockSelector.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisBlockSelector.rgb)
if thisBlockSelector != None:
    for paramName in thisBlockSelector:
        exec('{} = thisBlockSelector[paramName]'.format(paramName))

for thisBlockSelector in blockSelector:
    currentLoop = blockSelector
    # abbreviate parameter names if possible (e.g. rgb = thisBlockSelector.rgb)
    if thisBlockSelector != None:
        for paramName in thisBlockSelector:
            exec('{} = thisBlockSelector[paramName]'.format(paramName))
    
    # --- Prepare to start Routine "blank2s" ---
    continueRoutine = True
    # update component parameters for each repeat
    # keep track of which components have finished
    blank2sComponents = [textBlank3s]
    for thisComponent in blank2sComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "blank2s" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 2.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textBlank3s* updates
        
        # if textBlank3s is starting this frame...
        if textBlank3s.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textBlank3s.frameNStart = frameN  # exact frame index
            textBlank3s.tStart = t  # local t and not account for scr refresh
            textBlank3s.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textBlank3s, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textBlank3s.started')
            # update status
            textBlank3s.status = STARTED
            textBlank3s.setAutoDraw(True)
        
        # if textBlank3s is active this frame...
        if textBlank3s.status == STARTED:
            # update params
            pass
        
        # if textBlank3s is stopping this frame...
        if textBlank3s.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textBlank3s.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                textBlank3s.tStop = t  # not accounting for scr refresh
                textBlank3s.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textBlank3s.stopped')
                # update status
                textBlank3s.status = FINISHED
                textBlank3s.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in blank2sComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "blank2s" ---
    for thisComponent in blank2sComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-2.000000)
    
    # --- Prepare to start Routine "seriesBlocks" ---
    continueRoutine = True
    # update component parameters for each repeat
    textSeriesBlocks.setText(versionText)
    key_respSeriesBlocks.keys = []
    key_respSeriesBlocks.rt = []
    _key_respSeriesBlocks_allKeys = []
    # keep track of which components have finished
    seriesBlocksComponents = [textSeriesBlocks, textSeriesBlocksSpacebar, key_respSeriesBlocks]
    for thisComponent in seriesBlocksComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "seriesBlocks" ---
    routineForceEnded = not continueRoutine
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textSeriesBlocks* updates
        
        # if textSeriesBlocks is starting this frame...
        if textSeriesBlocks.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textSeriesBlocks.frameNStart = frameN  # exact frame index
            textSeriesBlocks.tStart = t  # local t and not account for scr refresh
            textSeriesBlocks.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textSeriesBlocks, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textSeriesBlocks.started')
            # update status
            textSeriesBlocks.status = STARTED
            textSeriesBlocks.setAutoDraw(True)
        
        # if textSeriesBlocks is active this frame...
        if textSeriesBlocks.status == STARTED:
            # update params
            pass
        
        # *textSeriesBlocksSpacebar* updates
        
        # if textSeriesBlocksSpacebar is starting this frame...
        if textSeriesBlocksSpacebar.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
            # keep track of start time/frame for later
            textSeriesBlocksSpacebar.frameNStart = frameN  # exact frame index
            textSeriesBlocksSpacebar.tStart = t  # local t and not account for scr refresh
            textSeriesBlocksSpacebar.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textSeriesBlocksSpacebar, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textSeriesBlocksSpacebar.started')
            # update status
            textSeriesBlocksSpacebar.status = STARTED
            textSeriesBlocksSpacebar.setAutoDraw(True)
        
        # if textSeriesBlocksSpacebar is active this frame...
        if textSeriesBlocksSpacebar.status == STARTED:
            # update params
            pass
        
        # *key_respSeriesBlocks* updates
        waitOnFlip = False
        
        # if key_respSeriesBlocks is starting this frame...
        if key_respSeriesBlocks.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
            # keep track of start time/frame for later
            key_respSeriesBlocks.frameNStart = frameN  # exact frame index
            key_respSeriesBlocks.tStart = t  # local t and not account for scr refresh
            key_respSeriesBlocks.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_respSeriesBlocks, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'key_respSeriesBlocks.started')
            # update status
            key_respSeriesBlocks.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_respSeriesBlocks.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_respSeriesBlocks.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_respSeriesBlocks.status == STARTED and not waitOnFlip:
            theseKeys = key_respSeriesBlocks.getKeys(keyList=['space'], waitRelease=False)
            _key_respSeriesBlocks_allKeys.extend(theseKeys)
            if len(_key_respSeriesBlocks_allKeys):
                key_respSeriesBlocks.keys = _key_respSeriesBlocks_allKeys[-1].name  # just the last key pressed
                key_respSeriesBlocks.rt = _key_respSeriesBlocks_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in seriesBlocksComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "seriesBlocks" ---
    for thisComponent in seriesBlocksComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if key_respSeriesBlocks.keys in ['', [], None]:  # No response was made
        key_respSeriesBlocks.keys = None
    blockSelector.addData('key_respSeriesBlocks.keys',key_respSeriesBlocks.keys)
    if key_respSeriesBlocks.keys != None:  # we had a response
        blockSelector.addData('key_respSeriesBlocks.rt', key_respSeriesBlocks.rt)
    # the Routine "seriesBlocks" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    Blocks = data.TrialHandler(nReps=1.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('blocks.xlsx'),
        seed=None, name='Blocks')
    thisExp.addLoop(Blocks)  # add the loop to the experiment
    thisBlock = Blocks.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
    if thisBlock != None:
        for paramName in thisBlock:
            exec('{} = thisBlock[paramName]'.format(paramName))
    
    for thisBlock in Blocks:
        currentLoop = Blocks
        # abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
        if thisBlock != None:
            for paramName in thisBlock:
                exec('{} = thisBlock[paramName]'.format(paramName))
        
        # --- Prepare to start Routine "blockStart" ---
        continueRoutine = True
        # update component parameters for each repeat
        textBlockStart.setText(blockInstructions)
        key_respBlockStart.keys = []
        key_respBlockStart.rt = []
        _key_respBlockStart_allKeys = []
        # keep track of which components have finished
        blockStartComponents = [textBlockStart, key_respBlockStart]
        for thisComponent in blockStartComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "blockStart" ---
        routineForceEnded = not continueRoutine
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textBlockStart* updates
            
            # if textBlockStart is starting this frame...
            if textBlockStart.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textBlockStart.frameNStart = frameN  # exact frame index
                textBlockStart.tStart = t  # local t and not account for scr refresh
                textBlockStart.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textBlockStart, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textBlockStart.started')
                # update status
                textBlockStart.status = STARTED
                textBlockStart.setAutoDraw(True)
            
            # if textBlockStart is active this frame...
            if textBlockStart.status == STARTED:
                # update params
                pass
            
            # *key_respBlockStart* updates
            waitOnFlip = False
            
            # if key_respBlockStart is starting this frame...
            if key_respBlockStart.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                key_respBlockStart.frameNStart = frameN  # exact frame index
                key_respBlockStart.tStart = t  # local t and not account for scr refresh
                key_respBlockStart.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(key_respBlockStart, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'key_respBlockStart.started')
                # update status
                key_respBlockStart.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(key_respBlockStart.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(key_respBlockStart.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if key_respBlockStart.status == STARTED and not waitOnFlip:
                theseKeys = key_respBlockStart.getKeys(keyList=['space'], waitRelease=False)
                _key_respBlockStart_allKeys.extend(theseKeys)
                if len(_key_respBlockStart_allKeys):
                    key_respBlockStart.keys = _key_respBlockStart_allKeys[-1].name  # just the last key pressed
                    key_respBlockStart.rt = _key_respBlockStart_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
                if eyetracker:
                    eyetracker.setConnectionState(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in blockStartComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "blockStart" ---
        for thisComponent in blockStartComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if key_respBlockStart.keys in ['', [], None]:  # No response was made
            key_respBlockStart.keys = None
        Blocks.addData('key_respBlockStart.keys',key_respBlockStart.keys)
        if key_respBlockStart.keys != None:  # we had a response
            Blocks.addData('key_respBlockStart.rt', key_respBlockStart.rt)
        # the Routine "blockStart" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        instructionStress = data.TrialHandler(nReps=stress, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='instructionStress')
        thisExp.addLoop(instructionStress)  # add the loop to the experiment
        thisInstructionStres = instructionStress.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisInstructionStres.rgb)
        if thisInstructionStres != None:
            for paramName in thisInstructionStres:
                exec('{} = thisInstructionStres[paramName]'.format(paramName))
        
        for thisInstructionStres in instructionStress:
            currentLoop = instructionStress
            # abbreviate parameter names if possible (e.g. rgb = thisInstructionStres.rgb)
            if thisInstructionStres != None:
                for paramName in thisInstructionStres:
                    exec('{} = thisInstructionStres[paramName]'.format(paramName))
            
            # --- Prepare to start Routine "instrusctionSpecific" ---
            continueRoutine = True
            # update component parameters for each repeat
            key_resp_2.keys = []
            key_resp_2.rt = []
            _key_resp_2_allKeys = []
            textInstructionsStress.setText('Respond as quickly as possible. That is, press either the ‘same’ key or the ‘different’ key as soon as you have made a decision about the\nsameness or difference of the two stimuli. Do not hesitate. Please press a key when you have made a decision even if the stimulus is still being presented.')
            # keep track of which components have finished
            instrusctionSpecificComponents = [textInstructionsSpacebar_2, key_resp_2, textInstructionsStress]
            for thisComponent in instrusctionSpecificComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "instrusctionSpecific" ---
            routineForceEnded = not continueRoutine
            while continueRoutine:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *textInstructionsSpacebar_2* updates
                
                # if textInstructionsSpacebar_2 is starting this frame...
                if textInstructionsSpacebar_2.status == NOT_STARTED and tThisFlip >= 4.0-frameTolerance:
                    # keep track of start time/frame for later
                    textInstructionsSpacebar_2.frameNStart = frameN  # exact frame index
                    textInstructionsSpacebar_2.tStart = t  # local t and not account for scr refresh
                    textInstructionsSpacebar_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textInstructionsSpacebar_2, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'textInstructionsSpacebar_2.started')
                    # update status
                    textInstructionsSpacebar_2.status = STARTED
                    textInstructionsSpacebar_2.setAutoDraw(True)
                
                # if textInstructionsSpacebar_2 is active this frame...
                if textInstructionsSpacebar_2.status == STARTED:
                    # update params
                    pass
                
                # *key_resp_2* updates
                waitOnFlip = False
                
                # if key_resp_2 is starting this frame...
                if key_resp_2.status == NOT_STARTED and tThisFlip >= 4-frameTolerance:
                    # keep track of start time/frame for later
                    key_resp_2.frameNStart = frameN  # exact frame index
                    key_resp_2.tStart = t  # local t and not account for scr refresh
                    key_resp_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_resp_2, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'key_resp_2.started')
                    # update status
                    key_resp_2.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_resp_2.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key_resp_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if key_resp_2.status == STARTED and not waitOnFlip:
                    theseKeys = key_resp_2.getKeys(keyList=['space'], waitRelease=False)
                    _key_resp_2_allKeys.extend(theseKeys)
                    if len(_key_resp_2_allKeys):
                        key_resp_2.keys = _key_resp_2_allKeys[-1].name  # just the last key pressed
                        key_resp_2.rt = _key_resp_2_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                
                # *textInstructionsStress* updates
                
                # if textInstructionsStress is starting this frame...
                if textInstructionsStress.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    textInstructionsStress.frameNStart = frameN  # exact frame index
                    textInstructionsStress.tStart = t  # local t and not account for scr refresh
                    textInstructionsStress.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textInstructionsStress, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'textInstructionsStress.started')
                    # update status
                    textInstructionsStress.status = STARTED
                    textInstructionsStress.setAutoDraw(True)
                
                # if textInstructionsStress is active this frame...
                if textInstructionsStress.status == STARTED:
                    # update params
                    pass
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in instrusctionSpecificComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "instrusctionSpecific" ---
            for thisComponent in instrusctionSpecificComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # check responses
            if key_resp_2.keys in ['', [], None]:  # No response was made
                key_resp_2.keys = None
            instructionStress.addData('key_resp_2.keys',key_resp_2.keys)
            if key_resp_2.keys != None:  # we had a response
                instructionStress.addData('key_resp_2.rt', key_resp_2.rt)
            # the Routine "instrusctionSpecific" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
        # completed stress repeats of 'instructionStress'
        
        
        # set up handler to look after randomisation of conditions etc
        instructionAccuracy = data.TrialHandler(nReps=accuracy, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='instructionAccuracy')
        thisExp.addLoop(instructionAccuracy)  # add the loop to the experiment
        thisInstructionAccuracy = instructionAccuracy.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisInstructionAccuracy.rgb)
        if thisInstructionAccuracy != None:
            for paramName in thisInstructionAccuracy:
                exec('{} = thisInstructionAccuracy[paramName]'.format(paramName))
        
        for thisInstructionAccuracy in instructionAccuracy:
            currentLoop = instructionAccuracy
            # abbreviate parameter names if possible (e.g. rgb = thisInstructionAccuracy.rgb)
            if thisInstructionAccuracy != None:
                for paramName in thisInstructionAccuracy:
                    exec('{} = thisInstructionAccuracy[paramName]'.format(paramName))
            
            # --- Prepare to start Routine "instructionsSpecific2" ---
            continueRoutine = True
            # update component parameters for each repeat
            textInstructions.setText('Press either the ‘SAME’ key or the ‘DIFFERENT’ key when you have made a decision about the sameness or difference of the two stimuli.\n')
            key_resp.keys = []
            key_resp.rt = []
            _key_resp_allKeys = []
            # keep track of which components have finished
            instructionsSpecific2Components = [textInstructions, key_resp, textInstructionsSpacebar]
            for thisComponent in instructionsSpecific2Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "instructionsSpecific2" ---
            routineForceEnded = not continueRoutine
            while continueRoutine:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *textInstructions* updates
                
                # if textInstructions is starting this frame...
                if textInstructions.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    textInstructions.frameNStart = frameN  # exact frame index
                    textInstructions.tStart = t  # local t and not account for scr refresh
                    textInstructions.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textInstructions, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'textInstructions.started')
                    # update status
                    textInstructions.status = STARTED
                    textInstructions.setAutoDraw(True)
                
                # if textInstructions is active this frame...
                if textInstructions.status == STARTED:
                    # update params
                    pass
                
                # *key_resp* updates
                waitOnFlip = False
                
                # if key_resp is starting this frame...
                if key_resp.status == NOT_STARTED and tThisFlip >= 3-frameTolerance:
                    # keep track of start time/frame for later
                    key_resp.frameNStart = frameN  # exact frame index
                    key_resp.tStart = t  # local t and not account for scr refresh
                    key_resp.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'key_resp.started')
                    # update status
                    key_resp.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if key_resp.status == STARTED and not waitOnFlip:
                    theseKeys = key_resp.getKeys(keyList=['space'], waitRelease=False)
                    _key_resp_allKeys.extend(theseKeys)
                    if len(_key_resp_allKeys):
                        key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
                        key_resp.rt = _key_resp_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                
                # *textInstructionsSpacebar* updates
                
                # if textInstructionsSpacebar is starting this frame...
                if textInstructionsSpacebar.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
                    # keep track of start time/frame for later
                    textInstructionsSpacebar.frameNStart = frameN  # exact frame index
                    textInstructionsSpacebar.tStart = t  # local t and not account for scr refresh
                    textInstructionsSpacebar.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textInstructionsSpacebar, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'textInstructionsSpacebar.started')
                    # update status
                    textInstructionsSpacebar.status = STARTED
                    textInstructionsSpacebar.setAutoDraw(True)
                
                # if textInstructionsSpacebar is active this frame...
                if textInstructionsSpacebar.status == STARTED:
                    # update params
                    pass
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in instructionsSpecific2Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "instructionsSpecific2" ---
            for thisComponent in instructionsSpecific2Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # check responses
            if key_resp.keys in ['', [], None]:  # No response was made
                key_resp.keys = None
            instructionAccuracy.addData('key_resp.keys',key_resp.keys)
            if key_resp.keys != None:  # we had a response
                instructionAccuracy.addData('key_resp.rt', key_resp.rt)
            # the Routine "instructionsSpecific2" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
        # completed accuracy repeats of 'instructionAccuracy'
        
        
        # set up handler to look after randomisation of conditions etc
        Block = data.TrialHandler(nReps=1.0, method='random', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(version),
            seed=None, name='Block')
        thisExp.addLoop(Block)  # add the loop to the experiment
        thisBlock = Block.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
        if thisBlock != None:
            for paramName in thisBlock:
                exec('{} = thisBlock[paramName]'.format(paramName))
        
        for thisBlock in Block:
            currentLoop = Block
            # abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
            if thisBlock != None:
                for paramName in thisBlock:
                    exec('{} = thisBlock[paramName]'.format(paramName))
            
            # --- Prepare to start Routine "blank2s" ---
            continueRoutine = True
            # update component parameters for each repeat
            # keep track of which components have finished
            blank2sComponents = [textBlank3s]
            for thisComponent in blank2sComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "blank2s" ---
            routineForceEnded = not continueRoutine
            while continueRoutine and routineTimer.getTime() < 2.0:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *textBlank3s* updates
                
                # if textBlank3s is starting this frame...
                if textBlank3s.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    textBlank3s.frameNStart = frameN  # exact frame index
                    textBlank3s.tStart = t  # local t and not account for scr refresh
                    textBlank3s.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textBlank3s, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'textBlank3s.started')
                    # update status
                    textBlank3s.status = STARTED
                    textBlank3s.setAutoDraw(True)
                
                # if textBlank3s is active this frame...
                if textBlank3s.status == STARTED:
                    # update params
                    pass
                
                # if textBlank3s is stopping this frame...
                if textBlank3s.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > textBlank3s.tStartRefresh + 2-frameTolerance:
                        # keep track of stop time/frame for later
                        textBlank3s.tStop = t  # not accounting for scr refresh
                        textBlank3s.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'textBlank3s.stopped')
                        # update status
                        textBlank3s.status = FINISHED
                        textBlank3s.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in blank2sComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "blank2s" ---
            for thisComponent in blank2sComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
            if routineForceEnded:
                routineTimer.reset()
            else:
                routineTimer.addTime(-2.000000)
            
            # --- Prepare to start Routine "standard" ---
            continueRoutine = True
            # update component parameters for each repeat
            # keep track of which components have finished
            standardComponents = [polygonStandard, textStandard]
            for thisComponent in standardComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "standard" ---
            routineForceEnded = not continueRoutine
            while continueRoutine and routineTimer.getTime() < 3.0:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *polygonStandard* updates
                
                # if polygonStandard is starting this frame...
                if polygonStandard.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    polygonStandard.frameNStart = frameN  # exact frame index
                    polygonStandard.tStart = t  # local t and not account for scr refresh
                    polygonStandard.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(polygonStandard, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'polygonStandard.started')
                    # update status
                    polygonStandard.status = STARTED
                    polygonStandard.setAutoDraw(True)
                
                # if polygonStandard is active this frame...
                if polygonStandard.status == STARTED:
                    # update params
                    pass
                
                # if polygonStandard is stopping this frame...
                if polygonStandard.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > polygonStandard.tStartRefresh + 1-frameTolerance:
                        # keep track of stop time/frame for later
                        polygonStandard.tStop = t  # not accounting for scr refresh
                        polygonStandard.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'polygonStandard.stopped')
                        # update status
                        polygonStandard.status = FINISHED
                        polygonStandard.setAutoDraw(False)
                
                # *textStandard* updates
                
                # if textStandard is starting this frame...
                if textStandard.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    textStandard.frameNStart = frameN  # exact frame index
                    textStandard.tStart = t  # local t and not account for scr refresh
                    textStandard.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textStandard, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'textStandard.started')
                    # update status
                    textStandard.status = STARTED
                    textStandard.setAutoDraw(True)
                
                # if textStandard is active this frame...
                if textStandard.status == STARTED:
                    # update params
                    pass
                
                # if textStandard is stopping this frame...
                if textStandard.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > textStandard.tStartRefresh + 2.0-frameTolerance:
                        # keep track of stop time/frame for later
                        textStandard.tStop = t  # not accounting for scr refresh
                        textStandard.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'textStandard.stopped')
                        # update status
                        textStandard.status = FINISHED
                        textStandard.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in standardComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "standard" ---
            for thisComponent in standardComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
            if routineForceEnded:
                routineTimer.reset()
            else:
                routineTimer.addTime(-3.000000)
            
            # --- Prepare to start Routine "trial" ---
            continueRoutine = True
            # update component parameters for each repeat
            key_respBorN.keys = []
            key_respBorN.rt = []
            _key_respBorN_allKeys = []
            # keep track of which components have finished
            trialComponents = [polygonBlackSquare, textTrialBorN, key_respBorN]
            for thisComponent in trialComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "trial" ---
            routineForceEnded = not continueRoutine
            while continueRoutine:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *polygonBlackSquare* updates
                
                # if polygonBlackSquare is starting this frame...
                if polygonBlackSquare.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    polygonBlackSquare.frameNStart = frameN  # exact frame index
                    polygonBlackSquare.tStart = t  # local t and not account for scr refresh
                    polygonBlackSquare.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(polygonBlackSquare, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'polygonBlackSquare.started')
                    # update status
                    polygonBlackSquare.status = STARTED
                    polygonBlackSquare.setAutoDraw(True)
                
                # if polygonBlackSquare is active this frame...
                if polygonBlackSquare.status == STARTED:
                    # update params
                    pass
                
                # if polygonBlackSquare is stopping this frame...
                if polygonBlackSquare.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > polygonBlackSquare.tStartRefresh + duration-frameTolerance:
                        # keep track of stop time/frame for later
                        polygonBlackSquare.tStop = t  # not accounting for scr refresh
                        polygonBlackSquare.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'polygonBlackSquare.stopped')
                        # update status
                        polygonBlackSquare.status = FINISHED
                        polygonBlackSquare.setAutoDraw(False)
                
                # *textTrialBorN* updates
                
                # if textTrialBorN is starting this frame...
                if textTrialBorN.status == NOT_STARTED and tThisFlip >= duration-frameTolerance:
                    # keep track of start time/frame for later
                    textTrialBorN.frameNStart = frameN  # exact frame index
                    textTrialBorN.tStart = t  # local t and not account for scr refresh
                    textTrialBorN.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textTrialBorN, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'textTrialBorN.started')
                    # update status
                    textTrialBorN.status = STARTED
                    textTrialBorN.setAutoDraw(True)
                
                # if textTrialBorN is active this frame...
                if textTrialBorN.status == STARTED:
                    # update params
                    pass
                
                # *key_respBorN* updates
                waitOnFlip = False
                
                # if key_respBorN is starting this frame...
                if key_respBorN.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    key_respBorN.frameNStart = frameN  # exact frame index
                    key_respBorN.tStart = t  # local t and not account for scr refresh
                    key_respBorN.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_respBorN, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'key_respBorN.started')
                    # update status
                    key_respBorN.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_respBorN.clock.reset)  # t=0 on next screen flip
                if key_respBorN.status == STARTED and not waitOnFlip:
                    theseKeys = key_respBorN.getKeys(keyList=['b','n'], waitRelease=False)
                    _key_respBorN_allKeys.extend(theseKeys)
                    if len(_key_respBorN_allKeys):
                        key_respBorN.keys = _key_respBorN_allKeys[0].name  # just the first key pressed
                        key_respBorN.rt = _key_respBorN_allKeys[0].rt
                        # was this correct?
                        if (key_respBorN.keys == str(corrAns)) or (key_respBorN.keys == corrAns):
                            key_respBorN.corr = 1
                        else:
                            key_respBorN.corr = 0
                        # a response ends the routine
                        continueRoutine = False
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in trialComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "trial" ---
            for thisComponent in trialComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # check responses
            if key_respBorN.keys in ['', [], None]:  # No response was made
                key_respBorN.keys = None
                # was no response the correct answer?!
                if str(corrAns).lower() == 'none':
                   key_respBorN.corr = 1;  # correct non-response
                else:
                   key_respBorN.corr = 0;  # failed to respond (incorrectly)
            # store data for Block (TrialHandler)
            Block.addData('key_respBorN.keys',key_respBorN.keys)
            Block.addData('key_respBorN.corr', key_respBorN.corr)
            if key_respBorN.keys != None:  # we had a response
                Block.addData('key_respBorN.rt', key_respBorN.rt)
            # the Routine "trial" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            
            # set up handler to look after randomisation of conditions etc
            trialsNoFeedback = data.TrialHandler(nReps=noFeedback, method='sequential', 
                extraInfo=expInfo, originPath=-1,
                trialList=[None],
                seed=None, name='trialsNoFeedback')
            thisExp.addLoop(trialsNoFeedback)  # add the loop to the experiment
            thisTrialsNoFeedback = trialsNoFeedback.trialList[0]  # so we can initialise stimuli with some values
            # abbreviate parameter names if possible (e.g. rgb = thisTrialsNoFeedback.rgb)
            if thisTrialsNoFeedback != None:
                for paramName in thisTrialsNoFeedback:
                    exec('{} = thisTrialsNoFeedback[paramName]'.format(paramName))
            
            for thisTrialsNoFeedback in trialsNoFeedback:
                currentLoop = trialsNoFeedback
                # abbreviate parameter names if possible (e.g. rgb = thisTrialsNoFeedback.rgb)
                if thisTrialsNoFeedback != None:
                    for paramName in thisTrialsNoFeedback:
                        exec('{} = thisTrialsNoFeedback[paramName]'.format(paramName))
                
                # --- Prepare to start Routine "yourResponseScreen" ---
                continueRoutine = True
                # update component parameters for each repeat
                # Run 'Begin Routine' code from codeYourResponse
                if key_respBorN.keys == 'b':
                    msg2 = 'You chose SAME'
                else:
                    msg2 = 'You chose DIFFERENT'  
                textYourResponse.setText(msg2)
                # keep track of which components have finished
                yourResponseScreenComponents = [textYourResponse]
                for thisComponent in yourResponseScreenComponents:
                    thisComponent.tStart = None
                    thisComponent.tStop = None
                    thisComponent.tStartRefresh = None
                    thisComponent.tStopRefresh = None
                    if hasattr(thisComponent, 'status'):
                        thisComponent.status = NOT_STARTED
                # reset timers
                t = 0
                _timeToFirstFrame = win.getFutureFlipTime(clock="now")
                frameN = -1
                
                # --- Run Routine "yourResponseScreen" ---
                routineForceEnded = not continueRoutine
                while continueRoutine and routineTimer.getTime() < 1.0:
                    # get current time
                    t = routineTimer.getTime()
                    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                    # update/draw components on each frame
                    
                    # *textYourResponse* updates
                    
                    # if textYourResponse is starting this frame...
                    if textYourResponse.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                        # keep track of start time/frame for later
                        textYourResponse.frameNStart = frameN  # exact frame index
                        textYourResponse.tStart = t  # local t and not account for scr refresh
                        textYourResponse.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(textYourResponse, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'textYourResponse.started')
                        # update status
                        textYourResponse.status = STARTED
                        textYourResponse.setAutoDraw(True)
                    
                    # if textYourResponse is active this frame...
                    if textYourResponse.status == STARTED:
                        # update params
                        pass
                    
                    # if textYourResponse is stopping this frame...
                    if textYourResponse.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > textYourResponse.tStartRefresh + 1.0-frameTolerance:
                            # keep track of stop time/frame for later
                            textYourResponse.tStop = t  # not accounting for scr refresh
                            textYourResponse.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'textYourResponse.stopped')
                            # update status
                            textYourResponse.status = FINISHED
                            textYourResponse.setAutoDraw(False)
                    
                    # check for quit (typically the Esc key)
                    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                        core.quit()
                        if eyetracker:
                            eyetracker.setConnectionState(False)
                    
                    # check if all components have finished
                    if not continueRoutine:  # a component has requested a forced-end of Routine
                        routineForceEnded = True
                        break
                    continueRoutine = False  # will revert to True if at least one component still running
                    for thisComponent in yourResponseScreenComponents:
                        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                            continueRoutine = True
                            break  # at least one component has not yet finished
                    
                    # refresh the screen
                    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                        win.flip()
                
                # --- Ending Routine "yourResponseScreen" ---
                for thisComponent in yourResponseScreenComponents:
                    if hasattr(thisComponent, "setAutoDraw"):
                        thisComponent.setAutoDraw(False)
                # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
                if routineForceEnded:
                    routineTimer.reset()
                else:
                    routineTimer.addTime(-1.000000)
            # completed noFeedback repeats of 'trialsNoFeedback'
            
            
            # set up handler to look after randomisation of conditions etc
            trialsFeedback = data.TrialHandler(nReps=feedback, method='sequential', 
                extraInfo=expInfo, originPath=-1,
                trialList=[None],
                seed=None, name='trialsFeedback')
            thisExp.addLoop(trialsFeedback)  # add the loop to the experiment
            thisTrialsFeedback = trialsFeedback.trialList[0]  # so we can initialise stimuli with some values
            # abbreviate parameter names if possible (e.g. rgb = thisTrialsFeedback.rgb)
            if thisTrialsFeedback != None:
                for paramName in thisTrialsFeedback:
                    exec('{} = thisTrialsFeedback[paramName]'.format(paramName))
            
            for thisTrialsFeedback in trialsFeedback:
                currentLoop = trialsFeedback
                # abbreviate parameter names if possible (e.g. rgb = thisTrialsFeedback.rgb)
                if thisTrialsFeedback != None:
                    for paramName in thisTrialsFeedback:
                        exec('{} = thisTrialsFeedback[paramName]'.format(paramName))
                
                # --- Prepare to start Routine "feedback" ---
                continueRoutine = True
                # update component parameters for each repeat
                # Run 'Begin Routine' code from code
                if key_respBorN.corr:
                    msg = 'Correct'
                else:
                    msg = 'Uncorrect'    
                textFeedback.setText(msg)
                # keep track of which components have finished
                feedbackComponents = [textFeedback]
                for thisComponent in feedbackComponents:
                    thisComponent.tStart = None
                    thisComponent.tStop = None
                    thisComponent.tStartRefresh = None
                    thisComponent.tStopRefresh = None
                    if hasattr(thisComponent, 'status'):
                        thisComponent.status = NOT_STARTED
                # reset timers
                t = 0
                _timeToFirstFrame = win.getFutureFlipTime(clock="now")
                frameN = -1
                
                # --- Run Routine "feedback" ---
                routineForceEnded = not continueRoutine
                while continueRoutine and routineTimer.getTime() < 1.0:
                    # get current time
                    t = routineTimer.getTime()
                    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                    # update/draw components on each frame
                    
                    # *textFeedback* updates
                    
                    # if textFeedback is starting this frame...
                    if textFeedback.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                        # keep track of start time/frame for later
                        textFeedback.frameNStart = frameN  # exact frame index
                        textFeedback.tStart = t  # local t and not account for scr refresh
                        textFeedback.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(textFeedback, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'textFeedback.started')
                        # update status
                        textFeedback.status = STARTED
                        textFeedback.setAutoDraw(True)
                    
                    # if textFeedback is active this frame...
                    if textFeedback.status == STARTED:
                        # update params
                        pass
                    
                    # if textFeedback is stopping this frame...
                    if textFeedback.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > textFeedback.tStartRefresh + 1-frameTolerance:
                            # keep track of stop time/frame for later
                            textFeedback.tStop = t  # not accounting for scr refresh
                            textFeedback.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'textFeedback.stopped')
                            # update status
                            textFeedback.status = FINISHED
                            textFeedback.setAutoDraw(False)
                    
                    # check for quit (typically the Esc key)
                    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                        core.quit()
                        if eyetracker:
                            eyetracker.setConnectionState(False)
                    
                    # check if all components have finished
                    if not continueRoutine:  # a component has requested a forced-end of Routine
                        routineForceEnded = True
                        break
                    continueRoutine = False  # will revert to True if at least one component still running
                    for thisComponent in feedbackComponents:
                        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                            continueRoutine = True
                            break  # at least one component has not yet finished
                    
                    # refresh the screen
                    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                        win.flip()
                
                # --- Ending Routine "feedback" ---
                for thisComponent in feedbackComponents:
                    if hasattr(thisComponent, "setAutoDraw"):
                        thisComponent.setAutoDraw(False)
                # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
                if routineForceEnded:
                    routineTimer.reset()
                else:
                    routineTimer.addTime(-1.000000)
            # completed feedback repeats of 'trialsFeedback'
            
            thisExp.nextEntry()
            
        # completed 1.0 repeats of 'Block'
        
        # get names of stimulus parameters
        if Block.trialList in ([], [None], None):
            params = []
        else:
            params = Block.trialList[0].keys()
        # save data for this loop
        Block.saveAsText(filename + 'Block.csv', delim=',',
            stimOut=params,
            dataOut=['n','all_mean','all_std', 'all_raw'])
        thisExp.nextEntry()
        
    # completed 1.0 repeats of 'Blocks'
    
    # get names of stimulus parameters
    if Blocks.trialList in ([], [None], None):
        params = []
    else:
        params = Blocks.trialList[0].keys()
    # save data for this loop
    Blocks.saveAsText(filename + 'Blocks.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
# completed 1.0 repeats of 'blockSelector'


# --- Prepare to start Routine "GoodbyeScreen" ---
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
GoodbyeScreenComponents = [textGoodbyeScreen]
for thisComponent in GoodbyeScreenComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "GoodbyeScreen" ---
routineForceEnded = not continueRoutine
while continueRoutine and routineTimer.getTime() < 3.0:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textGoodbyeScreen* updates
    
    # if textGoodbyeScreen is starting this frame...
    if textGoodbyeScreen.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textGoodbyeScreen.frameNStart = frameN  # exact frame index
        textGoodbyeScreen.tStart = t  # local t and not account for scr refresh
        textGoodbyeScreen.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textGoodbyeScreen, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textGoodbyeScreen.started')
        # update status
        textGoodbyeScreen.status = STARTED
        textGoodbyeScreen.setAutoDraw(True)
    
    # if textGoodbyeScreen is active this frame...
    if textGoodbyeScreen.status == STARTED:
        # update params
        pass
    
    # if textGoodbyeScreen is stopping this frame...
    if textGoodbyeScreen.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > textGoodbyeScreen.tStartRefresh + 3.0-frameTolerance:
            # keep track of stop time/frame for later
            textGoodbyeScreen.tStop = t  # not accounting for scr refresh
            textGoodbyeScreen.frameNStop = frameN  # exact frame index
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textGoodbyeScreen.stopped')
            # update status
            textGoodbyeScreen.status = FINISHED
            textGoodbyeScreen.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in GoodbyeScreenComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "GoodbyeScreen" ---
for thisComponent in GoodbyeScreenComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
if routineForceEnded:
    routineTimer.reset()
else:
    routineTimer.addTime(-3.000000)

# --- End experiment ---
# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
